{*******************************************************}
{                                                       }
{                AUTHOR Andrei Roofin                   }
{                                                       }
{              www - http://dsr.tomsk.ru                }
{             mail - ray@mail.tomsknet.ru               }
{                                                       }
{*******************************************************}
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Classes;

// Check Delphi and CBuilder versions
{$IFDEF VER100}
   {$DEFINE RSL_D3}
   {$DEFINE RSL_CB3LE}
   {$DEFINE RSL_D4LE}
   {$DEFINE RSL_CB4LE}
{$ENDIF}

{$IFDEF VER110}
   {$DEFINE RSL_CB3}
   {$DEFINE RSL_CB3LE}
   {$DEFINE RSL_D4LE}
   {$DEFINE RSL_CB4LE}
{$ENDIF}

{$IFDEF VER120}
   {$DEFINE RSL_D4}
   {$DEFINE RSL_D4LE}
   {$DEFINE RSL_CB4LE}
{$ENDIF}

{$IFDEF VER125}
   {$DEFINE RSL_CB4}
   {$DEFINE RSL_CB4LE}
{$ENDIF}

{$IFDEF VER130}
   {$DEFINE RSL_D5}
{$ENDIF}

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Edit1: TEdit;
    Button4: TButton;
    FontDialog1: TFontDialog;
    Label2: TLabel;
    Memo1: TMemo;
    procedure Button4Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

function InstancePropsToStr(Instance: TPersistent): String;
procedure StrToInstanceProps(Value: string; Instance: TPersistent);

var
  Form1: TForm1;

implementation

{$R *.DFM}

{$IFDEF RSL_CB4LE}
type
  THackReader = class(TReader);
{$ELSE}
type
  THackWriter = class(TWriter);
  THackReader = class(TReader);
{$ENDIF}


function InstancePropsToStr(Instance: TPersistent): String;
var
  ms: TMemoryStream;
  Writer: TWriter;
  p: pointer;
begin
  ms := TMemoryStream.Create;
  Writer := TWriter.Create(ms, 4096);

// hacking: calculate address of WriteProperties method in Delphi3,4,CBulder3,4
{$IFDEF RSL_CB4LE}
  p := @TWriter.WriteCollection;
  if PByte(p)^=$FF then begin //skip jmp table (for package)
    Inc(PByte(p), $2);
    p := Pointer(PInteger(p)^);
    p := Pointer(PInteger(p)^);
  end;
{$IFDEF RSL_CB3}
  Inc(PByte(p), $47);
{$ELSE}
  Inc(PByte(p), $37);
{$ENDIF}
  if PByte(PChar(p)-1)^<>$E8 then begin Result := ''; exit; end;
  Inc(PByte(p), PInteger(p)^+4);
  if PByte(p)^<>$55 then begin Result := ''; exit; end;
  asm
    push eax
    push edx
    mov eax, writer
    mov edx, Instance
    call p
    pop edx
    pop eax
  end;
{$ELSE}
  THackWriter(writer).WriteProperties(Instance);
{$ENDIF}

  Writer.WriteListEnd;
  Writer.FlushBuffer;
  ms.Position := 0;
  SetLength(Result, ms.Size);
  Move(ms.Memory^, PChar(Result)^, ms.Size);
  Writer.Free;
  ms.Free;
end;


procedure StrToInstanceProps(Value: string; Instance: TPersistent);
var
  ms: TMemoryStream;
  Reader: TReader;
{$IFDEF RSL_CB3LE}
  p: pointer;
{$ENDIF}  
begin
  ms := TMemoryStream.Create;
  Reader := TReader.Create(ms, 4096);
  ms.Write(PChar(Value)^, Length(Value));

// hacking: calculate address of ReadProperty method in Delphi3, CBuilder3
{$IFDEF RSL_CB3LE}
  p := @TReader.ReadCollection;
  if PByte(p)^=$FF then begin  //skip jmp table (for package)
    Inc(PByte(p), $2);
    p := Pointer(PInteger(p)^);
    p := Pointer(PInteger(p)^);
  end;
  {$IFDEF RSL_CB3}
    Inc(PByte(p), $6A);
  {$ELSE}
    Inc(PByte(p), $62);
  {$ENDIF}
  if PByte(PChar(p)-1)^<>$E8 then exit;
  Inc(PByte(p), PInteger(p)^+4);
  if PByte(p)^<>$55 then exit;
{$ENDIF}

  ms.Position := 0;
  while not Reader.EndOfList do
{$IFDEF RSL_CB3LE}
    asm
     push eax
     push edx
     mov eax, reader
     mov edx, Instance
     call p
     pop edx
     pop eax
    end;
{$ELSE}
   THackReader(reader).ReadProperty(Instance);
{$ENDIF}
  Reader.Free;
  ms.Free;
end;


procedure TForm1.Button4Click(Sender: TObject);
begin
  FontDialog1.Font.Assign(Edit1.Font);
  if FontDialog1.Execute then Edit1.Font.Assign(FontDialog1.Font);
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  ms: TMemoryStream;
  Reader: TReader;
  Writer: TWriter;
  collection: TCollection;
begin
  ms := TMemoryStream.Create;
  Reader := TReader.Create(ms, 4096);
  Writer := TWriter.Create(ms, 4096);
  collection := TCollection.Create(nil);
  try
    {Set breakpoint, Open CPU Window and manually calculate offset(in bytes) from
     begin of WriteCollection to call WriteProperties.
     It must be: Delphi3,4,CBuilder4  - $37 bytes, CBuilder3 - $47 bytes}
    Writer.WriteCollection(collection);

    {Set breakpoint, Open CPU Window and manually calculate offset(in bytes) from
     begin of ReadCollection to call ReadProperty.
     It must be: Delphi3  - $62 bytes, CBuilder3 - $6A bytes
     Don't worry about "Stream read error" exception. It occurs because
     of an empty Stream.}
    Reader.ReadCollection(collection);
  finally
    collection.Free;
    Writer.Free;
    Reader.Free;
    ms.Free;
  end;
end;

{save font to file}
procedure TForm1.Button3Click(Sender: TObject);
var
  s,FileName: string;
  f: TFileStream;
begin
  s := InstancePropsToStr(Edit1.Font);  //save Edit1.Font to s
  // save s to file
  FileName := ExtractFilePath(Application.ExeName)+'font.sav';
  f := TFileStream.Create(FileName, fmCreate);
  f.Write(PChar(s)^, Length(s));
  f.Free;
end;

{load font from file}
procedure TForm1.Button2Click(Sender: TObject);
var
  s,FileName: string;
  f: TFileStream;
begin
  FileName := ExtractFilePath(Application.ExeName)+'font.sav';
  if FileExists(FileName) then begin
    f := TFileStream.Create(FileName, fmOpenRead);
    SetLength(s, f.Size);
    f.Read(PChar(s)^, f.Size); // load s from file
    StrToInstanceProps(s, Edit1.Font); // load Edit1.Font from s
    f.Free;
  end;
end;

end.
